/* yasep/doc/docs.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created mer. sept. 14 22:22:46 CEST 2011
A generic documentation page loader,
and a collection of routines and properties for some pages

20120829: not restricted to doc/ anymore,
  merged 16-32.js, asm.js, forms.js
 */

init_obj.push(DOC_GEN={
  valid_keys:{ // The keys that are handled by this routine

    "doc/multiply":{
      titles:["Multiply",
              "Multiplications"]},

    "doc/reg-mem":{
      titles:["Registers and memory",
              "Registres et mémoire"],
      onLoad:function(cont,h){
        // Generate the register map
        var i,t='<center><table style="font-family: monospace">',
            r=getById("regtable","DIV",cont);
        if (r) {
          for (i in Y.registers_names)
            t+='<tr style="background-color:#'+(i&1?'EEE':'FFF')+'"><td>#'
                +i+':</td><td class="'+Y.registers_names[i][0]+'">&nbsp;<a href="#'
                +Y.registers_names[i]+'">'+Y.registers_names[i]+"</a>&nbsp;</td></tr>";
          r.innerHTML=t+"</table></center>";
        }
      }
    },

    "doc/16-32":{
      titles:["16&nbsp;vs&nbsp;32&nbsp;bits",
              "16&nbsp;ou&nbsp;32&nbsp;bits&nbsp;?"],
      onLoad: function(cont, h){
        var f, Usage16=[], Usage32=[];
        // scan the list of opcodes
        for (var name in Y.table_opcode) {
          if (Y.table_opcode[name].forms>0) {
            f=Y.table_opcode[name].flags;
            if (Y.YASEP16_ONLY & f)
              Usage16.push(Y.decorate_opcode(name));
            if (Y.YASEP32_ONLY & f)
              Usage32.push(Y.decorate_opcode(name));
          }
        }
        if(Usage16.length)
          getById("y16","div",cont).innerHTML=Usage16.sort().join(" ");
        if(Usage32.length)
          getById("y32","div",cont).innerHTML=Usage32.sort().join(" ");
      }
    },

/*
 docs/forms.js
 created 20090730 by whygee@f-cpu.org

Displays the list of the instructions available for every form
(inspired by opcode_map.js)

20110916 : htmi, added flags too
*/
    "doc/forms":{
      titles:["Instruction&nbsp;forms",
              "Formes&nbsp;d'instructions"],
      onLoad: function(cont, h){
        var a,b,c,d,e,i, FormUsage=[], // build the table of the forms
          pr="<hr>"+hiddenText(1,h); // "This form is used by these instructions : "

        // scan the list of the opcodes
        for (c in Y.table_opcode)
          if (Y.table_opcode[c].forms>0) {
            e=Y.table_opcode[c];
            t=" "+Y.decorate_opcode(c);
            i=1;
            while (i<=e.forms) {
              if (i & e.forms) {
                b=Y.TableForm[i];
                if (typeof FormUsage[b] != "string")
                  FormUsage[b]=pr+t;
                else
                  FormUsage[b]+=t;
              }
              i+=i;
            }
          }

        // scan all the <div class="ex"> of the page
        d=cont.getElementsByTagName("div");
        for (a in d)
          if (d[a].className=="ex") {
            b=d[a];
            c=FormUsage[b.id.slice(1)];
            if(typeof c=="string")
              b.innerHTML=c;
          }
      }
    },

    "doc/flags":{
      titles:["Instruction&nbsp;flags",
              "Attributs&nbsp;d'instructions"],
      onLoad: function(cont, h){
        var a,b,c,d,e,i, FlagsUsage=[], // build the table of the flags
          pr1=hiddenText(1,h); // "The flag "
          pr2=hiddenText(2,h); // " is used by these instructions : "

        // scan the list of the opcodes
        for (c in Y.table_opcode)
          if (Y.table_opcode[c].flags>0) {
            e=Y.table_opcode[c];
            t=" "+Y.decorate_opcode(c);
            i=1;
            while (i<=e.flags) {
              if (i & e.flags) {
                b=Y.TableFlags[i];
                if (!FlagsUsage[b])
                  FlagsUsage[b]="<br>"+pr1+"<b>"+b+"</b>"+pr2;
                FlagsUsage[b]+=t;
              }
              i+=i;
            }
          }

        // scan all the <div class="ex"> of the page
        d=cont.getElementsByTagName("div");
        for (a in d)
          if (d[a].className=="ex") {
            b=d[a];
            c=FlagsUsage[b.id.slice(1)];
            if(typeof c=="string")
              b.innerHTML=c+"<br>&nbsp;";
          }
      }
    },

// asm.js : version jeu. sept. 15 06:18:29 CEST 2011
    "doc/asm":{
      titles:["Assembly&nbsp;language",
              "Langage&nbsp;assembleur"],
      onLoad: function(cont, h){
        var t=[],i=0;
        for (var u in Y.table_opcode) {
          if (Y.table_opcode[u].forms >0) // no alias ?
            t[i++]=Y.decorate_opcode(u);
        }
        getById("opcodes","span",cont).innerHTML=t.sort().join(" ");

        t=[];i=0;
        for (var u in Y.tableConditionAll)
          t[i++]=u;
        document.getElementById("condcodes").innerHTML=t.sort().join(" ");
      }
    },

    "doc/firstrun":{
      titles:["First&nbsp;steps",
              "Premiers&nbsp;pas"],
      menu:"windows",
      style:"ms2_ylrd",
      onLoad: function(cont, h){
        var w=ygwm.getParent(cont);
        ygwm.changeDimensions(
         Math.ceil((getWidth() *3)/4),
         Math.ceil((getHeight()*3)/4),w);
        w.move(0, 0);

        if (!cookies.first_run)
          getById("NoCookie","p",cont).innerHTML="";

        if (browsLang != LANG.LN) // is it a fallback or a manual choice ?
          getById("changelang","span",cont).innerHTML=LS(
             "your language code is <tt>"+browsLang+"</tt>"
             +(LANG.supported?"":"</tt> but it is not supported"),
             "votre code de langue est <tt>"+browsLang+"</tt>"
             +(LANG.supported?"":"</tt> mais cette langue n'est pas encore supportée")
          );
      }
    },

    "doc/TutoNewWin":{
      titles:["Tutorial: how to create a window",
              "Tutoriel: Créer une fenêtre"],
      menu:"windows",
      onLoad: function(cont,h){
        var h="";
        for (var i in winman.window_keys)
          h+=' <a href="#!'+i+'" onclick="winman.activate_window(\''+i+'\')">'+i+"</a></li>";
        getById("window_keys_list","div",cont).innerHTML=h;
      }
    }

  },


//////////////////////////////////////////////////////////////////////////////////////

// This function is now a generic way to create,
// display and populate/update the ygwm windows
  start: function(key) {
    var k=DOC_GEN.valid_keys[key],
        s=k.style||"doc_cyan",
        cont=document.createElement("DIV");

    cont.innerHTML=import_htmi(key);

    // get the hidden DIV where language-specific snippets are stored
    var h=getByClass("hiddenDiv","DIV",cont),
      win = ygwm.new_window(
       h?hiddenText(0,h):key, null, cont,
       500, 400, 250, 250, false, true, true, true, false, s),

    // run an eventual page-specific routine
      f=k.onLoad;
    if (typeof f == "function")
      f(cont,h);

    winman.patchInnerLinks(cont);  // contains autoindex now
    return win;
  },

  init_obj: function(){
    for (var key in DOC_GEN.valid_keys) {
      var t=DOC_GEN.valid_keys[key],
          m=t.menu||"Doc";
      winman.register_key(key,DOC_GEN.start);
      menu.subMenuItem(menu.list[m], t.titles, key);
    }
  }
});


////////////////////////////////////////////////
// For the example in asm.xx.html that uses emit_bin :
function emit_bin_example(){
  var asmout=document.getElementById("emitbin_example"),
      msgout=document.getElementById("emitbin_msg"),
      asmin =document.getElementById("ex_asm_input").value,
      h="",m="",
      emit_bin_buffer= new Y.ASM_context(
        function(col,msg){  // message display routine
          m +='\n<span style="background-color:'+col+'">&nbsp;</span> '+msg;
        },
        function(data, size){//  emit_bin_buffer.emit_bin
          while (size--) { // displays every byte
            h+=" "+int2hex(data&255);
            data>>=8;
          }
          h+=", ";
        }
      );

  Y.encode_instruction(asmin,emit_bin_buffer);
  asmout.innerHTML=h;
  msgout.innerHTML=m;
};
